var DIM=64;
var FILE='/Users/randrews/Desktop/tst2png/pngs/ward_set_1.png';

var sidebar=new Sidebar();
Window.sidebar=sidebar;

function makeModebar(sidebar){
    var modes={};
    var oldMode=null;

    var modeSelector={
	type:'select',
	options:[],
	onselect:function(idx){
	    if(oldMode){
		for(var k=0;k<oldMode.length;k++){
		    sidebar[k+1]=null;
		}
	    }
	    oldMode=modes[this.options[idx]];
	    for(var k=0;k<oldMode.length;k++){
		sidebar[k+1]=oldMode[k];
	    }
	}
    };

    sidebar[0]=modeSelector;

    sidebar.addMode=function(name,widgets){
	modes[name]=widgets;
	modeSelector.options.push(name);
	if(modeSelector.options.length==1){
	    modeSelector.onselect.apply(modeSelector,[0]);
	}
    }
}

makeModebar(sidebar);

if(!KEY){
    var KEY=loadImage(FILE,DIM);
}

var data=getImageData(KEY);

var artMap=new Map(data.maxx,data.maxy,DIM);
var n=0;
for(var y=0;y<data.maxy;y++){
    for(var x=0;x<data.maxx;x++){
	artMap.spaces[x][y]={file:KEY,num:n++};
    }
}
artMap.highlight=new Piece({shape:'outline',color:'green'});

artMap.onclick=function(x,y,b){
    artMap.place(artMap.highlight,x,y);
    artMap.selectedNum=x+y*artMap.width;
};


var terrainTypes=new ItemList();
var lastTerrainIdx=0;

sidebar.addMode('Available art',
		[{type:'button',
			 label:'New Terrain',
			    onclick:function(){
			    var num=artMap.selectedNum;
			    if(!num){return;}
			    terrainTypes[lastTerrainIdx++]={
				piece:new Piece{file:KEY,num:num},
				label:'New Terrain'
			    };
			}},
		    {type:'button',
			    label:'New Item',
			    onclick:function(){
			    
			}},
		    artMap]);

sidebar.addMode('Terrain',
		[terrainTypes,
		 'Name:',
		 {type:'input',value:''},
		 {type:'space'}
		 
]);

sidebar.repaint();





